Loading...
Searching...
No Matches
wayland::server::zwp_linux_dmabuf_v1_t Class Reference

factory for creating dmabuf-based wl_buffers More...

`#include <wayland-server-protocol-unstable.hpp>`

Inherits wayland::server::resource_t.

## Public Member Functions

std::function< void()> & | on_destroy ()
| unbind the factory
std::function< void(zwp_linux_buffer_params_v1_t)> & | on_create_params ()
| create a temporary object for buffer parameters
std::function< void(zwp_linux_dmabuf_feedback_v1_t)> & | on_get_default_feedback ()
| get default feedback
std::function< void(zwp_linux_dmabuf_feedback_v1_t, surface_t)> & | on_get_surface_feedback ()
| get feedback for a surface
void | format (uint32_t format, bool post=true)
| supported buffer format
void | modifier (uint32_t format, uint32_t modifier_hi, uint32_t modifier_lo, bool post=true)
| supported buffer format modifier
bool | can_modifier () const
| Check whether the modifier function is available with the currently bound version of the protocol.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
void | post_no_memory () const
uint32_t | get_id () const
client_t | get_client () const
unsigned int | get_version () const
std::string | get_class ()

## Static Public Attributes

static constexpr std::uint32_t | format_since_version = 1
| Minimum protocol version required for the format function.
static constexpr std::uint32_t | modifier_since_version = 3
| Minimum protocol version required for the modifier function.

## Detailed Description

factory for creating dmabuf-based wl_buffers

Following the interfaces from: https://www.khronos.org/registry/egl/extensions/EXT/EGL_EXT_image_dma_buf_import.txt https://www.khronos.org/registry/EGL/extensions/EXT/EGL_EXT_image_dma_buf_import_modifiers.txt and the Linux DRM sub-system's AddFb2 ioctl.

This interface offers ways to create generic dmabuf-based wl_buffers.

Clients can use the get_surface_feedback request to get dmabuf feedback for a particular surface. If the client wants to retrieve feedback not tied to a surface, they can use the get_default_feedback request.

The following are required from clients:

- Clients must ensure that either all data in the dma-buf is coherent for all subsequent read access or that coherency is correctly handled by the underlying kernel-side dma-buf implementation.
- Don't make any more attachments after sending the buffer to the compositor. Making more attachments later increases the risk of the compositor not being able to use (re-import) an existing dmabuf-based wl_buffer.

The underlying graphics stack must ensure the following:

- The dmabuf file descriptors relayed to the server will stay valid for the whole lifetime of the wl_buffer. This means the server may at any time use those fds to import the dmabuf into any kernel sub-system that might accept it.

However, when the underlying graphics stack fails to deliver the promise, because of e.g. a device hot-unplug which raises internal errors, after the wl_buffer has been successfully created the compositor must not raise protocol errors to the client when dmabuf import later fails.

To create a wl_buffer from one or more dmabufs, a client creates a zwp_linux_dmabuf_params_v1 object with a zwp_linux_dmabuf_v1.create_params request. All planes required by the intended format are added with the 'add' request. Finally, a 'create' or 'create_immed' request is issued, which has the following outcome depending on the import success.

The 'create' request,

- on success, triggers a 'created' event which provides the final wl_buffer to the client.
- on failure, triggers a 'failed' event to convey that the server cannot use the dmabufs received from the client.

For the 'create_immed' request,

- on success, the server immediately imports the added dmabufs to create a wl_buffer. No event is sent from the server in this case.
- on failure, the server can choose to either:
  - terminate the client by raising a fatal error.
  - mark the wl_buffer as failed, and send a 'failed' event to the client. If the client uses a failed wl_buffer as an argument to any request, the behaviour is compositor implementation-defined.

For all DRM formats and unless specified in another protocol extension, pre-multiplied alpha is used for pixel values.

Warning! The protocol described in this file is experimental and backward incompatible changes may be made. Backward compatible changes may be added together with the corresponding interface version bump. Backward incompatible changes are done by bumping the version number in the protocol and interface names and resetting the interface version. Once the protocol is to be declared stable, the 'z' prefix and the version number in the protocol and interface names are removed and the interface version number is reset.

Definition at line 1631 of file wayland-server-protocol-unstable.hpp.

## Member Function Documentation

## can_modifier()

bool zwp_linux_dmabuf_v1_t::can_modifier | ( |  | ) | const

Check whether the modifier function is available with the currently bound version of the protocol.

Definition at line 4960 of file wayland-server-protocol-unstable.cpp.

## format()

void zwp_linux_dmabuf_v1_t::format | ( | uint32_t | format,
|  | bool | post = `true`
| ) |  |

supported buffer format

Parameters

  format | DRM_FORMAT code

This event advertises one buffer format that the server supports. All the supported formats are advertised once when the client binds to this interface. A roundtrip after binding guarantees that the client has received all supported formats.

For the definition of the format codes, see the zwp_linux_buffer_params_v1::create request.

Starting version 4, the format event is deprecated and must not be sent by compositors. Instead, use get_default_feedback or get_surface_feedback.

Definition at line 4950 of file wayland-server-protocol-unstable.cpp.

## get_class()

std::string wayland::server::resource_t::get_class | ( |  | ) |

inherited

Retrieve the interface name (class) of a resource object.

Returns
  Interface name of the resource object.

## get_client()

client_t wayland::server::resource_t::get_client | ( |  | ) | const

inherited

Get the associated client

Returns
  the client that owns the resource.

## get_id()

uint32_t wayland::server::resource_t::get_id | ( |  | ) | const

inherited

Get the internal ID of the resource

Returns
  the internal ID of the resource

## get_version()

unsigned int wayland::server::resource_t::get_version | ( |  | ) | const

inherited

Get interface version

Returns
  Interface version this resource has been constructed with.

## modifier()

void zwp_linux_dmabuf_v1_t::modifier | ( | uint32_t | format,
|  | uint32_t | modifier_hi,
|  | uint32_t | modifier_lo,
|  | bool | post = `true`
| ) |  |

supported buffer format modifier

Parameters

  format | DRM_FORMAT code
  modifier_hi | high 32 bits of layout modifier
  modifier_lo | low 32 bits of layout modifier

This event advertises the formats that the server supports, along with the modifiers supported for each format. All the supported modifiers for all the supported formats are advertised once when the client binds to this interface. A roundtrip after binding guarantees that the client has received all supported format-modifier pairs.

For legacy support, DRM_FORMAT_MOD_INVALID (that is, modifier_hi == 0x00ffffff and modifier_lo == 0xffffffff) is allowed in this event. It indicates that the server can support the format with an implicit modifier. When a plane has DRM_FORMAT_MOD_INVALID as its modifier, it is as if no explicit modifier is specified. The effective modifier will be derived from the dmabuf.

A compositor that sends valid modifiers and DRM_FORMAT_MOD_INVALID for a given format supports both explicit modifiers and implicit modifiers.

For the definition of the format and modifier codes, see the zwp_linux_buffer_params_v1::create and zwp_linux_buffer_params_v1::add requests.

Starting version 4, the modifier event is deprecated and must not be sent by compositors. Instead, use get_default_feedback or get_surface_feedback.

Definition at line 4955 of file wayland-server-protocol-unstable.cpp.

## on_create_params()

std::function< void(zwp_linux_buffer_params_v1_t)> & zwp_linux_dmabuf_v1_t::on_create_params | ( |  | ) |

create a temporary object for buffer parameters

Parameters

  params_id | the new temporary

This temporary object is used to collect multiple dmabuf handles into a single batch to create a wl_buffer. It can only be used once and should be destroyed after a 'created' or 'failed' event has been received.

Definition at line 4932 of file wayland-server-protocol-unstable.cpp.

## on_destroy()

std::function< void()> & zwp_linux_dmabuf_v1_t::on_destroy | ( |  | ) |

unbind the factory

Objects created through this interface, especially wl_buffers, will remain valid.

Definition at line 4926 of file wayland-server-protocol-unstable.cpp.

## on_get_default_feedback()

std::function< void(zwp_linux_dmabuf_feedback_v1_t)> & zwp_linux_dmabuf_v1_t::on_get_default_feedback | ( |  | ) |

get default feedback

Parameters

  id |

This request creates a new wp_linux_dmabuf_feedback object not bound to a particular surface. This object will deliver feedback about dmabuf parameters to use if the client doesn't support per-surface feedback (see get_surface_feedback).

Definition at line 4938 of file wayland-server-protocol-unstable.cpp.

## on_get_surface_feedback()

std::function< void(zwp_linux_dmabuf_feedback_v1_t, surface_t)> & zwp_linux_dmabuf_v1_t::on_get_surface_feedback | ( |  | ) |

get feedback for a surface

Parameters

  id |
  surface |

This request creates a new wp_linux_dmabuf_feedback object for the specified wl_surface. This object will deliver feedback about dmabuf parameters to use for buffers attached to this surface.

If the surface is destroyed before the wp_linux_dmabuf_feedback object, the feedback object becomes inert.

Definition at line 4944 of file wayland-server-protocol-unstable.cpp.

## post_no_memory()

void wayland::server::resource_t::post_no_memory | ( |  | ) | const

inherited

Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

## proxy_has_object()

bool wayland::server::resource_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## Member Data Documentation

## format_since_version

constexpr std::uint32_t wayland::server::zwp_linux_dmabuf_v1_t::format_since_version = 1

static constexpr

Minimum protocol version required for the format function.

Definition at line 1724 of file wayland-server-protocol-unstable.hpp.

## modifier_since_version

constexpr std::uint32_t wayland::server::zwp_linux_dmabuf_v1_t::modifier_since_version = 3

static constexpr

Minimum protocol version required for the modifier function.

Definition at line 1760 of file wayland-server-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp